
;Menu im Canvas-Gadget

Macro AuswahlKorrigieren
  ;AuswahlKorrigieren:
  ;Auswahl\ObenLinks und Auswahl\UntenRechts\ vertauschen, wenn
  ;Auswahl\ObenLinks > Auswahl\UntenRechts\
  ;Variablen cx und cy als Zhlvariablen "Protected" deklarieren
  ;Variablen x,y,x1,y1,x2,y2 fr Koordinaten als "Protected" deklarieren
  ;In x steht die Lnge der horizontalen Seiten des Auswahlrechtcks (also dessen Breite)
  ;In y steht die Lnge der vertikalen Seiten des Auswahlrechtcks (also dessen Hhe)  
  Protected x1=Auswahl\ObenLinks\x,y1=Auswahl\ObenLinks\y
  Protected x2=Auswahl\UntenRechts\x,y2=Auswahl\UntenRechts\y
  Protected x,y,cx,cy
  If x1>x2:Swap x1,x2:EndIf
  If y1>y2:Swap y1,y2:EndIf
  x=x2-x1
  y=y2-y1
EndMacro

Procedure AuswahlZufaelligFuellen()
  Protected prozent=Val(InputRequester("Auswahl zufllig fllen","Prozentwert eingeben (0=Abbruch)","50"))
  Protected w,p,zx,zy,dx,dy
  ;Auswahl\Status=#AuswahlInaktiv
  If prozent=0:ConwayAnzeigen():ProcedureReturn :EndIf
  AuswahlKorrigieren
  For dy=y1 To y2-1
    For dx=x1 To x2-1
      If Conway(dx,dy)=1:Population-1:EndIf 
      Conway(dx,dy)=0
    Next
  Next
  w=(x*y*prozent)/100 ; <- Prozentrechnung
  x-1
  y-1
  Repeat
    zx=Random(x)
    zy=Random(y)
    If Conway(x1+zx,y1+zy)=0
      Conway(x1+zx,y1+zy)=1
      p+1
    EndIf
  Until p=w
  Population+p
  ConwayAnzeigen()
EndProcedure

Procedure AuswahlKopieren()
  AuswahlKorrigieren
  x-1
  y-1
  Dim AusschneidenKopierenEinfuegen(x,y)
  For cy=0 To y
    For cx=0 To x
      AusschneidenKopierenEinfuegen(cx,cy)=Conway(cx+x1,cy+y1)
    Next
  Next  
EndProcedure

Procedure AuswahlAusschneiden()
  AuswahlKorrigieren
  x-1
  y-1
  Dim AusschneidenKopierenEinfuegen(x,y)
  For cy=0 To y
    For cx=0 To x
      AusschneidenKopierenEinfuegen(cx,cy)=Conway(cx+x1,cy+y1)
      If Conway(cx+x1,cy+y1)=1:Population-1:EndIf
      Conway(cx+x1,cy+y1)=0
    Next
  Next    
  ConwayAnzeigen()
EndProcedure

Procedure AuswahlSpiegeln(spiegeln)
  AuswahlKorrigieren
  Select spiegeln
    Case #SpiegelnHorizontal
      x/2
      For cy=y1 To y2
        For cx=0 To x
          Swap Conway(cx+x1,cy),Conway(x2-cx,cy)
        Next
      Next
    Case #SpiegelnVertikal
      y/2
      For cy=0 To y
        For cx=x1 To x2
          Swap Conway(cx,cy+y1),Conway(cx,y2-cy)
        Next
      Next
  EndSelect
  Auswahl\Status=#AuswahlInaktiv
  ConwayAnzeigen()
EndProcedure

Procedure AuswahlDrehen(drehen)
  AuswahlKorrigieren
    If x>y  ;Auswahl "quadratisch machen", ist dann einfacher zu drehen 
    y=x
    y2=y1+y
  EndIf
  If y>x
    x=y
    x2=x1+x
  EndIf
  Dim drehung.b(x,y)
  Dim drehung2.b(x,y)
  For cy=0 To y ;Quellbereich in Hilfsarray kopieren
    For cx=0 To x
      drehung(cx,cy)=Conway(x1+cx,y1+cy)
    Next
  Next   
  Select drehen
    Case #Drehen180
      For cy=0 To y
        For cx=0 To x
          drehung2(x-cx,y-cy)=drehung(cx,cy)
        Next
      Next  
    Case #Drehen90Links
      For cy=0 To y
        For cx=0 To x
          drehung2(cy,x-cx)=drehung(cx,cy)
        Next
      Next      
    Case #Drehen90Rechts
      For cy=0 To y
        For cx=0 To x
          drehung2(y-cy,cx)=drehung(cx,cy)
        Next
      Next
  EndSelect
  For cy=0 To y
    For cx=0 To x
      Conway(x1+cx,y1+cy)=drehung2(cx,cy)
    Next
  Next
  Auswahl\Status=#AuswahlInaktiv
  ConwayAnzeigen()
EndProcedure

Procedure AuswahlZoomen()
  AuswahlKorrigieren
  If x>y
    Zellengroesse=x
  Else
    Zellengroesse=y
  EndIf
  Zellengroesse=800/Zellengroesse
  If Zellengroesse>100:Zellengroesse=100:EndIf
  cx=Auswahl\ObenLinks\x-1
  cy=Auswahl\ObenLinks\y-1
  SetGadgetAttribute(#ScrollArea_0,#PB_ScrollArea_InnerWidth,Zellengroesse*Conway_Breite)
  SetGadgetAttribute(#ScrollArea_0,#PB_ScrollArea_InnerHeight,Zellengroesse*Conway_Hoehe)
  SetGadgetAttribute(#ScrollArea_0,#PB_ScrollArea_X,cx*Zellengroesse)
  SetGadgetAttribute(#ScrollArea_0,#PB_ScrollArea_Y,cy*Zellengroesse) 
  SetGadgetAttribute(#ScrollArea_0,#PB_ScrollArea_ScrollStep,400) ; <- fehlt im Formdesigner
  ResizeGadget(#Canvas,#PB_Ignore,#PB_Ignore,Zellengroesse*Conway_Breite,Zellengroesse*Conway_Hoehe) 
  Auswahl\Status=#AuswahlInaktiv
  ConwayAnzeigen()
EndProcedure

Procedure Eingabemaske()
  Protected c,e,g,f=0 ;f=1 wenn ok, f=2 wenn Abbruch oder CloseWindow
  Protected name.s
  OpenWindow_2()
  DisableWindow(#Window_0,#True)
  SetGadgetText(#string_1002,GetGadgetText(#wirdgeboren))
  SetGadgetText(#string_1003,GetGadgetText(#ueberlebt))
  SetActiveGadget(#String_1000)
  Repeat
    f=0
    While f=0
      e=WaitWindowEvent()
      If e=#PB_Event_CloseWindow:f=2:EndIf
      If e=#PB_Event_Gadget
        If EventGadget()=#Button_1000:f=1:EndIf
        If EventGadget()=#Button_1001:f=2:EndIf
      EndIf  
    Wend
    If f=2
      CloseWindow(#Window_2)
      DisableWindow(#Window_0,#False)
      ProcedureReturn #False
    EndIf
    name=GetGadgetText(#String_1000)
    If name<>"":Break:EndIf
    MessageRequester("Fehler","Bitte einen Namen fr das Objekt eingeben!",#PB_MessageRequester_Warning)
  ForEver
  AddElement(EigeneObjekte())
  With EigeneObjekte()
    \Regel="b"+GetGadgetText(#string_1002)+"/s"+GetGadgetText(#string_1003)
    \Name=name  
    \Autor=GetGadgetText(#String_1001)
    \Infotext=""
    For c=0 To CountGadgetItems(#Editor_1000)-1
      \Infotext+GetGadgetItemText(#Editor_1000,c)+#CRLF$
    Next
    \gespeichert=#False
    AddGadgetItem(#EigeneObjekte,-1,\name+Chr(10)+\Regel)
  EndWith
  CloseWindow(#Window_2)
  DisableWindow(#Window_0,#False)  
  ProcedureReturn #True  
EndProcedure

Procedure AuswahlSichern()  ;als eigenes Objekt in selbiger Liste
                            ;TODO Fenster ffnen, darin Name und Infotext abfragen und die Regel
  AuswahlKorrigieren
  x-1
  y-1
  If Eingabemaske()=#False:ProcedureReturn :EndIf
  EigeneObjekte()\Breite=x
  EigeneObjekte()\Hoehe=y
  Dim RLESpeicher(x,y)
  For cy=0 To y
    For cx=0 To x
      RLESpeicher(cx,cy)=Conway(x1+cx,y1+cy)
    Next
  Next 
  RLE_Kodieren(x,y,EigeneObjekte()\RLE_String())
EndProcedure


;Menu in ListIcon-Gadget "Geladene Objekte" bzw. "Eigene Objekte"

Procedure ObjektInfo()
  Protected o.sObjekte,text.s
  If AusgewaehltesObjekt>0
    SelectElement(Objekte(),AusgewaehltesObjekt-1)
    o=Objekte()
  ElseIf AusgewaehltesObjekt<0
    AusgewaehltesObjekt*-1
    SelectElement(EigeneObjekte(),AusgewaehltesObjekt-1)
    With EigeneObjekte()
      o\Name=\Name
      o\Breite=\Breite
      o\Hoehe=\Hoehe
      o\Infotext=\Infotext
      ;o\RLE_String()=\RLE_String()
      o\Regel=\Regel
      o\Autor=\Autor
    EndWith
  EndIf
  text="Name :"+o\Name+#CRLF$+"Autor : "+o\Autor+#CRLF$+"Kommentar :"+#CRLF$+o\Infotext+#CRLF$+"Regel  : "+
       o\Regel+#CRLF$+"Hhe  : "+Str(o\Hoehe)+#CRLF$+"Breite : "+Str(o\Breite)
  MessageRequester("Info",text)
EndProcedure

Procedure ObjektAusListeEntfernen()
  Protected lig=#geladeneobjekte
  If AusgewaehltesObjekt<0
    lig=#eigeneobjekte
    AusgewaehltesObjekt*-1
    SelectElement(EigeneObjekte(),AusgewaehltesObjekt-1)
    DeleteElement(EigeneObjekte())
  Else
    SelectElement(Objekte(),AusgewaehltesObjekt-1)
    DeleteElement(Objekte())
  EndIf
  RemoveGadgetItem(lig,AusgewaehltesObjekt-1)
  AusgewaehltesObjekt=0
EndProcedure


; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 170
; Folding = Ai
; EnableXP
; CompileSourceDirectory